'use strict';

exports.__esModule = true;
exports.safeJsonReadSync = safeJsonReadSync;
exports.outputFileStderrSync = outputFileStderrSync;

var _fsExtraPromise = require('fs-extra-promise');

var _fsExtraPromise2 = _interopRequireDefault(_fsExtraPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function safeJsonReadSync(file) {
  // returns obj, error, or undefined when not found
  try {
    var stat = _fsExtraPromise2['default'].statSync(file);
    if (stat && stat.size) {
      try {
        return _fsExtraPromise2['default'].readJsonSync(file);
      } catch (err) {
        return err;
      }
    }
    return undefined;
  } catch (err) {
    if (err.code !== 'ENOENT') {
      console.error(err);
      return err;
    }
    return undefined;
  }
}

function outputFileStderrSync(file) {
  var content = _fsExtraPromise2['default'].readFileSync(file);
  process.stderr.write(content);
}