'use strict';

exports.__esModule = true;
exports.createLogUpdate = createLogUpdate;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _numeral = require('numeral');

var _numeral2 = _interopRequireDefault(_numeral);

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _rxjs = require('rxjs');

var _format = require('./format');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// eslint-disable-next-line import/prefer-default-export
function createLogUpdate(config, rtenv) {
  // throttle logging of scan updates
  var logUpdate$ = new _rxjs.Subject();
  var linkSaved = config.dryrun ? 'saves:' : 'saved:';
  logUpdate$.throttleTime(100) // throttle scan updates 100ms each
  .subscribe(function () {
    rtenv.log(_chalk2['default'].blue('pkgs:') + ' ' + (0, _numeral2['default'])(rtenv.completedPackages).format('0,0') + '/' + (0, _numeral2['default'])(rtenv.packageCount).format('0,0') + ' ' + _chalk2['default'].green(linkSaved) + ' ' + _chalk2['default'].bold((0, _format.formatBytes)(rtenv.savedByteCount)) + ' ' + _chalk2['default'].dim((0, _format.trunc)(config.extraCols, rtenv.currentPackageDir)));
  });

  return function logUpdate() {
    logUpdate$.next();
  };
}