'use strict';

exports.__esModule = true;

var _managedChild = require('./managed-child');

var _managedChild2 = _interopRequireDefault(_managedChild);

var _managedMaster = require('./managed-master');

var _managedMaster2 = _interopRequireDefault(_managedMaster);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var INTERRUPT_TYPE = 'INTERRUPT_SHUTDOWN';

/*
  Handles setting up signals and if we are running
  a child process then it hooks signals up so we can
  do a graceful shutdown on Control-c including from
  Windows.
 */

var launchWorkerMain = function launchWorkerMain() {}; // defined later

function launchWorker(script, opts) {
  return launchWorkerMain(script, opts);
}

if (process.disconnect) {
  // running as a child
  var childMethods = (0, _managedChild2['default'])(INTERRUPT_TYPE);
  launchWorker.onInterrupt = childMethods.onInterrupt;
  launchWorker.shutdown = childMethods.shutdown;
} else {
  // otherwise running as master
  var masterMethods = (0, _managedMaster2['default'])(INTERRUPT_TYPE);
  launchWorkerMain = masterMethods.launchChildWorker;
  launchWorker.onInterrupt = masterMethods.onInterrupt;
  launchWorker.shutdown = masterMethods.shutdown;
}

exports['default'] = launchWorker;